//#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* DtapiUtility.h *#*#*#*#*#*#*#* (C) 2000-2004 DEKTEC

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- License -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// This program is free software; You can freely use/modify this source code in any way
// you desire, including for commercial applications.
//

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Change History -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//	MG	19-11-2002	Created	based on DTAPI for windows

#ifndef __DTAPIUTILITY_H
#define __DTAPIUTILITY_H
//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+ Internal DTAPI Helper Class +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

// This class is used to hide global functions that are used internally in the DTAPI only
struct __DTAPI {
        static DTAPI_RESULT  ResetOutputChannel(HANDLE,	Int, Int);
        static DTAPI_RESULT  SetTxControl(HANDLE, Int, Int, Int);
		static Bool  GetIoConfigViaDta1xx(HANDLE, Int, Int&);

        static DTAPI_RESULT ReadRegister(HANDLE, Int, Int, Int&);
		static Bool  SetIoConfigViaDta1xx(HANDLE, Int, Int);
		static DTAPI_RESULT WriteRegister(HANDLE, Int, Int, Int);
};
//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- DtDeviceInt -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// Helper class to hide internal implementation functions from DTAPI.h
//
class DtDeviceInt : public DtDevice {

	// Internal helper functions
public:
	__int64  GetSerialFromVpd(void);

	DTAPI_RESULT  VpdDeleteResource(char*, unsigned char*, unsigned int);
	bool  VpdFindResource(char*, unsigned char*, unsigned int, unsigned char*&);
	bool  VpdIsValidResource(unsigned char*, unsigned char*, unsigned int);
	unsigned int  VpdSectionLength(unsigned char*, unsigned int);

	DTAPI_RESULT  VpdReadRaw(unsigned char*, unsigned int, unsigned int);
	DTAPI_RESULT  VpdWriteRaw(unsigned char*, unsigned int, unsigned int);
};


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Helper Constants -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

// Value for DtapiDeviceScan parameter 'ScanType'
const int  SCAN_FULL		= 0;
const int  ATTACH_TO_SERIAL	= 1;
const int  ATTACH_TO_SLOT	= 2;
const int  ATTACH_TO_TYPE	= 3;


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Global Functions -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
DTAPI_RESULT  DtapiCheckDeviceDriverVersion(int, int, int, int, int);
DTAPI_RESULT  DtapiDeviceScan(int, int,	int&, DtDeviceDesc*, DtDevice*,
							  int, int, int, int, __int64);
extern int  DtapiDeviceId2TypeNumber(int SubsystemId);
int TxMode2PacketSize(int TxPacketMode);


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Macro's -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define CHECKDR(expr)	{ dr = expr; if (dr!=DTAPI_OK) return dr; }

// Helpers
int min(int a, int b);
void Sleep(int ms);

#endif // __DTAPIUTILITY_H
