//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* Dta1xxVpd.h *#*#*#*#*#*#*#*#* (C) 2000-2005 DEKTEC

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- License -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// This program is free software; You can freely use/modify this source code in any way
// you desire, including for commercial applications.
//

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Change History -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//	MG	2003.04.23	Created. Based on windows driver code

#ifndef __DTA1XXVPD_H
#define __DTA1XXVPD_H

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Constants -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

// EEPROM attached to PLX 9054/9056
#define  PLX_VPD_SIZE			512

// Start of VPD sections
#define EEPROM_VPD_ID_START		0x58		// Read-only section directly follows VPD-ID
#define EEPROM_VPD_RW_START		0x100
#define EEPROM_VPD_END			0x1FF

// Section length
#define EEPROM_VPD_ID_RO_LENGTH	(EEPROM_VPD_RW_START - EEPROM_VPD_ID_START)
#define EEPROM_VPD_RW_LENGTH	(EEPROM_VPD_END - EEPROM_VPD_RW_START)

// Total length. The final +1 is for VPD End tag
#define EEPROM_VPD_TOTAL_LENGTH	(EEPROM_VPD_ID_RO_LENGTH + EEPROM_VPD_RW_LENGTH + 1)

// Maximum length of VPD-resource string
#define VPD_ITEM_MAX_LENGTH		63			// 64 if trailing '\0' is factored in


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Macro's -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.

#define VALID_VPD_KEYW_CHAR(c) 	(((c)>='0' && (c)<='9') || ((c)>='A' && (c)<='Z'))

#endif //__DTA1XXVPD_H
