//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* Target.c *#*#*#*#*#*#*#*#*# (C) 2000-2005 DEKTEC

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- License -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// This program is free software; You can freely use/modify this source code in any way
// you desire, including for commercial applications.
//

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Change History -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//	MG	21-10-2002	Created	

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Include files -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#include "../Include/Dta1xx.h"
#include "../Include/Dta1xxRegs.h"
#include <linux/delay.h>

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Type definitions -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

//.-.-.-.-.-.-.-.-.-.-.-.-.-.- internal function declarations -.-.-.-.-.-.-.-.-.-.-.-.-.-.
void  Dta1xxReadTargetId(DTA1XX_FDO* pFdo, int* pnTargetId);
void  Dta1xxSenseAtoDUsingDacA(DTA1XX_FDO* pFdo, int* pAdcValue);
void  Dta1xxSenseAtoDUsingDacB(DTA1XX_FDO* pFdo, int* pAdcValue);
void  Dta1xxSetTargetIdWindow(DTA1XX_FDO* pFdo);
void  Dta1xxSetWindowForGrounded(DTA1XX_FDO* pFdo);
void  Dta1xxSetWindowForOpenCircuit(DTA1XX_FDO* pFdo);
void  Dta1xxWaitForUpdateDone(char* pTxRegs);

//-.-.-.-.-.-.-.-.-.-.-.-.-.- Data declaration and definition -.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define	 GROUNDED		0		// DVB-SPI cable connected => sense input is grounded
#define  OPEN_CIRCUIT	36		// Nothing connected to 25p subD connector

//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+ Implementation +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

//.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxTargetDetectStateMachine -.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// Main state machine for target-adapter detection.
// Called from periodic interrupt handler.
//
// See DTA-102/122 Design Document for graphical state diagram.
//
void Dta1xxTargetDetectStateMachine(
		DTA1XX_FDO* pFdo,	// Functional device object, representing the DTA-1xx card
		int nChIdx)		// Channel ID
{
}


//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxReadTargetId -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
void Dta1xxReadTargetId(
	DTA1XX_FDO* pFdo,	// Functional device object, representing the DTA-1xx card
	int*  pnTargetId)	// Target ID 1..35; 0=GROUNDED; 36=OPEN_CIRCUIT
{
}

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxSenseAtoDUsingDacA -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
//
// Emulate A-to-D conversion on sense input, by performing a binary search with the DAC
// and monitoring the comparator output. Uses DAC A.
//
void Dta1xxSenseAtoDUsingDacA(
	DTA1XX_FDO*  pFdo,	// Functional device object, representing the DTA-1xx card
	int*  pAdcValue)	// Measured value for voltage on sense input (0=0V ... 255=5V)
{
}


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxSetTargetIdWindow -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// Set a window of +/- 3 LSBs around currently measured voltage on sense pin.
// Comparator A implements lower threshold. 1=ok, 0=below threshold.
// Comparator B implements upper threshold. 0=ok, 1=above threshold.
//
void Dta1xxSetTargetIdWindow(
		DTA1XX_FDO*  pFdo)	// Functional device object, representing the DTA-1xx card
{
}


//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxSetWindowForGrounded -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// Set comparator A, such that 0=GROUNDED, 0=not grounded anymore
//
void Dta1xxSetWindowForGrounded(
		DTA1XX_FDO*  pFdo)	// Functional device object, representing the DTA-1xx card
{
}


//.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxSetWindowForOpenCircuit -.-.-.-.-.-.-.-.-.-.-.-.-.-.-
//
// Set comparator A, such that 1=OPEN_CIRCUIT, 0=something connected
//
void Dta1xxSetWindowForOpenCircuit(
		DTA1XX_FDO*	pFdo)		// Functional device object, representing the DTA-1xx card
{
}


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxWaitForUpdateDone -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// Wait until DAC has been updated. Don't wait too long, to avoid system crash if
// something is wrong with the DAC...
//
void Dta1xxWaitForUpdateDone(
		char*  pTxRegs)
{
}
