//#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* Utility.c *#*#*#*#*#*#*#*#*# (C) 2000-2005 DEKTEC

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- License -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// This program is free software; You can freely use/modify this source code in any way
// you desire, including for commercial applications.
//

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Change History -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//      JH      13-07-2005      Added support for non-PLX cards (DTA-105/545)
//	MG	21-10-2002	Created

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Include files -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#include "../Include/Dta1xx.h"

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Type definitions -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

//.-.-.-.-.-.-.-.-.-.-.-.-.-.- Internal function declarations -.-.-.-.-.-.-.-.-.-.-.-.-.-.

//-.-.-.-.-.-.-.-.-.-.-.-.-.- Data declaration and definition -.-.-.-.-.-.-.-.-.-.-.-.-.-.

//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+ Implementation +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxDeviceId2TypeNumber -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
//
// Computes the type number based on the subsystem ID or device ID
// (formerly Dta1xxSubsystemId2TypeNumber)
//
int Dta1xxDeviceId2TypeNumber(
		int nDeviceId)	// Subsytem ID or Device ID of the device
{
        return nDeviceId - (nDeviceId < 0xD100 ? 0 : (0xD100-100)); 
}

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Dta1xxTxMode2PacketSize -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
// Computes the packet size based on the Transmit mode
//
int Dta1xxTxMode2PacketSize(
		int  nTxPacketMode)		// Packet transmit mode (TxMode, BurstMode)
{
	switch (nTxPacketMode & 0x0F) {
	case DTA1XX_TXMODE_188:		return 188;
	case DTA1XX_TXMODE_192:		return 192;
	case DTA1XX_TXMODE_204:		return 204;
	case DTA1XX_TXMODE_ADD16:	return 204;
	case DTA1XX_TXMODE_MIN16:	return 204;
	case DTA1XX_TXMODE_RAW:		return 188;
	default:					return 188;		// Should not occur
	}
}
