//#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* Dtu2xxCodes.h *#*#*#*#*#*#*#*# (C) 2000-2006 DekTec
//
// This code is the intellectual property of DekTec Digital Video B.V. and may not be
// distributed, in its original or in altered form, without the explicit permission of
// DekTec Digital Video B.V.

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Change History -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//	2004.07.19	MG	Created	

#ifndef __DTU2XXCODES_H
#define __DTU2XXCODES_H

typedef UInt32 DTU2XX_RESULT;


//+=+=+=+=+=+=+=+=+=+=+ General definitions for the DTU-2xx devices +=+=+=+=+=+=+=+=+=+=+=

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- ALTERA program mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define DTU2XX_START_PROG_CYCLE		1
#define DTU2XX_STOP_PROG_CYCLE		0

//+=+=+=+=+=+=+=+=+ Definitions below must match definitions in DTAPI.h! +=+=+=+=+=+=+=+=+

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- EEPROM Control -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_EEPROM_PROTECT		0x1FEE32CC
#define  DTU2XX_EEPROM_PROTECT_CLR	0x28392A3B

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.- ASI Polarity-Control Status -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_ASIINV_NORMAL	0
#define  DTU2XX_ASIINV_INVERT	1

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- ASI Input-Clock Lock -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_ASI_NOLOCK		    0
#define  DTU2XX_ASI_INLOCK		    1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Clock Detector -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_CLKDET_FAIL		    0
#define  DTU2XX_CLKDET_OK		    1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Input Rate Ok -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_INPRATE_LOW		    0
#define  DTU2XX_INPRATE_OK		    1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- #Invalid Bytes per Packet -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_NUMINV_NONE		    0
#define  DTU2XX_NUMINV_16		    1
#define  DTU2XX_NUMINV_OTHER	    2

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Equaliser Settings -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_EQUALISER_OFF	    0
#define  DTU2XX_EQUALISER_ON	    1

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Polarity Control -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_POLARITY_AUTO		0
#define  DTU2XX_POLARITY_NORMAL		2
#define  DTU2XX_POLARITY_INVERTED	3

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Packet Size -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_PCKSIZE_INV		    0
#define  DTU2XX_PCKSIZE_188		    2
#define  DTU2XX_PCKSIZE_204		    3

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Receive Control -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_RXCTRL_IDLE		    0
#define  DTU2XX_RXCTRL_RCV		    1

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Receive Mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_RXMODE_ST188	    0
#define  DTU2XX_RXMODE_ST204	    1
#define  DTU2XX_RXMODE_STMP2	    2
#define  DTU2XX_RXMODE_STRAW	    3
#define  DTU2XX_RXMODE_STTRP	    4
#define  DTU2XX_RX_TIMESTAMP	    8
#define  DTU2XX_RXMODE_SDI			0x10
#define  DTU2XX_RXMODE_SDI_10BIT	0x20
#define  DTU2XX_RXMODE_MASK		    0x07	// Mask for RxMode without timestamping flag

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Burst mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define DTU2XX_BURSTMODE_OFF	    0
#define DTU2XX_BURSTMODE_ON		    1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Packet stuff mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define DTU2XX_STUFFMODE_OFF	    0
#define DTU2XX_STUFFMODE_ON		    1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Clock-Generator Modes -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_TXCLOCK_INTERNAL	0
#define  DTU2XX_TXCLOCK_EXTERNAL	1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Detach Mode flags -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_INSTANT_DETACH		1
#define  DTU2XX_ZERO_OUTPUT			2
#define  DTU2XX_TRISTATE_OUTPUT		4
#define  DTU2XX_WAIT_UNTIL_SENT		8

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- LED Control -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_LED_OFF				0
#define  DTU2XX_LED_GREEN			1
#define  DTU2XX_LED_RED				2
#define  DTU2XX_LED_YELLOW			3
#define  DTU2XX_LED_HARDWARE		4

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Loop-Back Mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_NO_LOOPBACK			0
#define  DTU2XX_LOOPBACK_MODE		1

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Packet Transmit Mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_TXMODE_188			0
#define  DTU2XX_TXMODE_204			1
#define  DTU2XX_TXMODE_ADD16		2
#define  DTU2XX_TXMODE_RAW			3
#define  DTU2XX_TXMODE_192			4		// Supported on DTA-102 Firmware Rev >= 2
#define  DTU2XX_TXMODE_130			5		// Supported on DTA-102 Firmware Rev >= 7
#define  DTU2XX_TXMODE_MIN16		6		// Supported on DTA-100 Firmware Rev >= 5
											// and          DTA-102 Firmware Rev >= 8
#define	 DTU2XX_TXMODE_MASK			0x0F	// Mask for TxMode without burst flag
#define	 DTU2XX_TXMODE_BURST		0x10	// Can be OR-ed with one of 188/192/204/ADD16/RAW
#define	 DTU2XX_TXMODE_SDI			0x40
#define	 DTU2XX_TXMODE_SDI_10BIT	0x80

#define  DTU2XX_TXMODE_STUFF_OFF	0x0
#define  DTU2XX_TXMODE_STUFF_ON		0x1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Transmit Polarity -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_TXPOL_NORMAL		0
#define  DTU2XX_TXPOL_INVERTED		1

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Reset Mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_FIFO_RESET			0
#define  DTU2XX_FULL_RESET			1

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Status Flags -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_RX_DMA_PENDING		1
#define  DTU2XX_RX_FIFO_OVF			2
#define  DTU2XX_RX_SYNC_ERR			4
#define  DTU2XX_RX_RATE_OVF			8
#define  DTU2XX_RX_TARGET_ERR		16

#define  DTU2XX_TX_DMA_PENDING		1
#define  DTU2XX_TX_FIFO_UFL			2
#define  DTU2XX_TX_SYNC_ERR			4
#define  DTU2XX_TX_READBACK_ERR		8
#define  DTU2XX_TX_TARGET_ERR		16

#define  DTU2XX_AUTO_CLEARFLAGS_OFF	0
#define  DTU2XX_AUTO_CLEARFLAGS_ON	1

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Transmit Control -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_TXCTRL_IDLE			0
#define  DTU2XX_TXCTRL_HOLD			1
#define  DTU2XX_TXCTRL_SEND			3

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Polarity Control -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#define  DTU2XX_POLARITY_AUTO		0
#define  DTU2XX_POLARITY_NORMAL		2
#define  DTU2XX_POLARITY_INVERT		3

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- SDRAM sizes -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define DTU2XX_SDRAM_SIZE_8MB		0
#define DTU2XX_SDRAM_SIZE_16MB		1
#define DTU2XX_SDRAM_SIZE_32MB		2

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Power Mode -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
#define  DTU2XX_POWER_OFF		    0
#define  DTU2XX_POWER_ON		    1

//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+ Result codes +=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+

// Feature not supported
#define  DTU2XX_NOT_SUPPORTED		-1

#define  DTU2XX_OK					0
#define  DTU2XX_E					0x1000
#define  DTU2XX_E_ATTACHED			(DTU2XX_E + 0)
#define  DTU2XX_E_BUF_TOO_SMALL		(DTU2XX_E + 1)
#define  DTU2XX_E_DEV_DRIVER		(DTU2XX_E + 2)
#define  DTU2XX_E_EEPROM_FULL		(DTU2XX_E + 3)
#define  DTU2XX_E_EEPROM_READ		(DTU2XX_E + 4)
#define  DTU2XX_E_EEPROM_WRITE		(DTU2XX_E + 5)
#define  DTU2XX_E_EEPROM_FORMAT		(DTU2XX_E + 6)
#define  DTU2XX_E_FIFO_FULL			(DTU2XX_E + 7)
#define  DTU2XX_E_IN_USE			(DTU2XX_E + 8)
#define  DTU2XX_E_INVALID_BUF		(DTU2XX_E + 9)
#define  DTU2XX_E_INVALID_CGMODE	(DTU2XX_E + 10)
#define  DTU2XX_E_INVALID_FLAGS		(DTU2XX_E + 11)
#define  DTU2XX_E_INVALID_MODE		(DTU2XX_E + 12)
#define  DTU2XX_E_INVALID_RATE		(DTU2XX_E + 13)
#define  DTU2XX_E_INVALID_SIZE		(DTU2XX_E + 14)
#define  DTU2XX_E_KEYWORD			(DTU2XX_E + 15)
#define  DTU2XX_E_NO_DTA_CARD		(DTU2XX_E + 16)
#define  DTU2XX_E_NO_LOOPBACK		(DTU2XX_E + 17)
#define  DTU2XX_E_NO_SUCH_DEVICE	(DTU2XX_E + 18)
#define  DTU2XX_E_NO_SUCH_OUTPUT	(DTU2XX_E + 19)
#define  DTU2XX_E_NO_TS_OUTPUT		(DTU2XX_E + 20)
#define  DTU2XX_E_NOT_ATTACHED		(DTU2XX_E + 21)
#define  DTU2XX_E_NOT_FOUND			(DTU2XX_E + 22)
#define  DTU2XX_E_NOT_SUPPORTED		(DTU2XX_E + 23)
#define  DTU2XX_E_PCICARD			(DTU2XX_E + 24)
#define  DTU2XX_E_TOO_LONG			(DTU2XX_E + 25)
#define  DTU2XX_E_UNDERFLOW			(DTU2XX_E + 26)
#define  DTU2XX_E_NO_SUCH_INPUT		(DTU2XX_E + 27)
#define  DTU2XX_E_NO_TS_INPUT		(DTU2XX_E + 28)

#endif // #ifndef __DTU2XXCODES_H
