//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* Dtu2xxVpd.h *#*#*#*#*#*#*#*#* (C) 2000-2006 DekTec
//
// This code is the intellectual property of DekTec Digital Video B.V. and may not be
// distributed, in its original or in altered form, without the explicit permission of
// DekTec Digital Video B.V.

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Change History -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//	MG	2003.04.23	Created. Based on windows driver code

#ifndef __DTU2XXVPD_H
#define __DTU2XXVPD_H

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Constants -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

// Start of VPD sections
#define EEPROM_VPD_ID_START		0x58		// Read-only section directly follows VPD-ID
#define EEPROM_VPD_RW_START		0x100
#define EEPROM_VPD_END			0x1FF

// Section length
#define EEPROM_VPD_ID_RO_LENGTH	(EEPROM_VPD_RW_START - EEPROM_VPD_ID_START)
#define EEPROM_VPD_RW_LENGTH	(EEPROM_VPD_END - EEPROM_VPD_RW_START)

// Total length. The final +1 is for VPD End tag
#define EEPROM_VPD_TOTAL_LENGTH	(EEPROM_VPD_ID_RO_LENGTH + EEPROM_VPD_RW_LENGTH + 1)

// Maximum length of VPD-resource string
#define VPD_ITEM_MAX_LENGTH		63			// 64 if trailing '\0' is factored in


//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Macro's -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.

#define VALID_VPD_KEYW_CHAR(c) 	(((c)>='0' && (c)<='9') || ((c)>='A' && (c)<='Z'))

#endif //__DTU2XXVPD_H
